class Switch
  VERSION = "0.0.2"

  class << self
    def in(input)
      stdin  = $stdin
      $stdin = StringIO.new(input).tap {|io| io.rewind}
      yield
      $stdin.read
    ensure
      $stdin = stdin
    end

    def out(return_io=false)
      pipe    = StringIO.new
      stdout  = $stdout
      $stdout = pipe
      yield
      return_io ? pipe : pipe.string
    ensure
      $stdout = stdout
    end

    def up(options)
      defaults = {
        stdout: false,
        stdin:  nil
      }
      options = defaults.merge options
      
      stdin  = $stdin
      stdout = $stdout

      $stdin  = StringIO.new(options[:stdin]).tap {|io| io.rewind}
      pipe    = StringIO.new
      $stdout = pipe

      yield
      
      return_values = {}
      return_values[:out] = options[:stdout] ? pipe : pipe.string
      return_values[:in]  = $stdin.read
      return_values
    ensure
      $stdin  = stdin
      $stdout = stdout
    end
  end

  def in(input)
    self.class.in(input)
  end
  def out(return_io=false)
    self.class.out(return_io)
  end
  def up(options)
    self.class.up(options)
  end
end
